Simplified Local Internet Number Resource Management (SLURM) with RPKI Autonomous System Provider Authorizations (ASPA)
Job Snijders
Fastly
Amsterdam
Netherlands
job@fastly.com
Ben Cartwright-Cox
Port 179 Ltd
London
United Kingdom
ben@benjojo.co.uk
OPS
SIDROPS
ASPA
EBGP
ISPs may want to establish a local view of exceptions to the Resource Public Key Infrastructure (RPKI) data in the form of local filters or additional attestations. This document defines an addendum to RFC 8416 by specifying a format for local filters and local assertions for Autonomous System Provider Authorizations (ASPA) for use with the RPKI.

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

Introduction
ISPs may want to establish a local view of exceptions to the Resource Public Key Infrastructure (RPKI) data in the form of local filters or additional attestations. This document defines an addendum to RFC 8416 by specifying a format for local filters and local assertions for Autonomous System Provider Authorizations (ASPA) for use with the RPKI.
See [RFC8416] for an overview of the SLURM mechanism, specifically Section 3 and Section 4.

SLURM v2 File Overview
A SLURM file consists of a single JSON [RFC8259] object containing the following members:
- A "slurmVersion" member that MUST be set to 2, encoded as a number
- A "validationOutputFilters" member whose value is an object. The object MUST contain exactly three members:
  - A "prefixFilters" member, see Section 3.3.1 [RFC8416]
  - A "bgpsecFilters" member, see section 3.3.2 [RFC8416]
  - A "aspaFilters" member, see Section 3.1
- A "locallyAddedAssertions" member whose value is an object. The object MUST contain exactly three members:
  - A "prefixAssertions" member, see Section 3.4.1 [RFC8416]
  - A "bgpsecAssertions" member, see Section 3.4.2 [RFC8416]
  - A "aspaAssertions" member, see Section 3.2
The following JSON structure with JSON members represents a SLURM file that has no filters or assertions:

{
  "slurmVersion": 2,
  "validationOutputFilters": {
    "aspaFilters": [],
    "bgpsecFilters": [],
    "prefixFilters": []
  },
  "locallyAddedAssertions": {
    "aspaAssertions": [],
    "bgpsecAssertions": [],
    "prefixAssertions": []
  }
}

Validation Output Filters for ASPA

Validated ASPA Filters
The RP can configure zero or more Validated ASPA Filters ("ASPA Filters" for short). Each ASPA Filter contains a single 'customerAsid' and optionally a single 'comment'.
- The 'customerAsid' member has as value a number.
- It is RECOMMENDED that an explanatory comment is included with each ASPA Filter so that it can be shown to users of the RP software.
Any Validated ASPA Payload (VAP) [I-D.ietf-sidrops-aspa-profile] that matches any configured ASPA Filter MUST be removed from the RP's output.
A VAP is considered to match with an ASPA Filter if the following condition applies:
1. The VAP is considered to match if the VAP Customer ASID is equal to the ASPA Filter Customer ASID.
The following example JSON structure represents a "aspaFilters" member with one object as described above:

"aspaFilter": [
  {
    "customerAsid": 64496,
    "comment": "Filter out ASPA Payloads which specify AS 64496 as the Customer ASID"
  }
]

Locally Added ASPA Assertions
Each RP is locally configured with a (possibly empty) array of ASPA Assertions. Each ASPA Assertion MUST contain a 'customerAsid' member containing the Customer ASID and a 'providerSet' array of numbers, reflecting the set of Provider ASNs. It is RECOMMENDED that an explanatory comment is also included so that it can be shown to users of the RP software.
The above is expressed as a value of the "aspaAssertions" member, as an array of zero or more objects. Each object MUST contain one each of all of the following members:
- An "customerAsid" member whose value is a number.
- A "providerSet" member whose value is an array of numbers.
- An optional "comment" member whose value is a string.
The following example JSON structure represents a "aspaAssertions" member with one object as described above:

"aspaAssertions": [
  {
    "customerAsid": 64496,
    "providerSet": [64497, 64498],
    "comment": "Locally assert 64497 are 64498 are providers to 64496"
  }
]

Note that an "aspaAssertions" member matches the syntax of the ASPA PDU described in Section 5.12 of [I-D.ietf-sidrops-8210bis]. Relying Parties MUST add any "aspaAssertions" member thus found to the set of ASPA PDUs, excluding duplicates, when using version 2 of the RPKI-Router protocol [I-D.ietf-sidrops-8210bis]. An "aspaAssertions" does not act as an implicit filter.

Example of a SLURM file with ASPA Filters and Assertions

{
  "slurmVersion": 2,
  "validationOutputFilters": {
    "prefixFilters": [
      {
        "prefix": "192.0.2.0/24",
        "comment": "All VRPs encompassed by prefix"
      },
      {
        "asn": 64496,
        "comment": "All VRPs matching ASN"
      },
      {
        "prefix": "198.51.100.0/24",
        "asn": 64497,
        "comment": "All VRPs encompassed by prefix, matching ASN"
      }
    ],
    "bgpsecFilters": [
      {
        "asn": 64496,
        "comment": "All keys for ASN"
      },
      {
        "SKI": "voibVdC3Nzl9dcSfSFuFj6mK0R8",
        "comment": "Key matching Router SKI"
      },
      {
        "asn": 64497,
        "SKI": "UQ9IXSminbe1FfnEePjtPLeqfSM",
        "comment": "Key for ASN 64497 matching Router SKI"
      }
    ],
    "aspaFilters": [
      {
        "customerAsid": 64496,
        "comment": "ASPAs matching Customer ASID 64496"
      }
    ]
  },
  "locallyAddedAssertions": {
    "prefixAssertions": [
      {
        "asn": 64496,
        "prefix": "198.51.100.0/24",
        "comment": "My other important route"
      },
      {
        "asn": 64496,
        "prefix": "2001:db8::/32",
        "maxPrefixLength": 48,
        "comment": "My other important de-aggregated routes"
      }
    ],
    "bgpsecAssertions": [
      {
        "asn": 64496,
        "comment" : "My known key for my important ASN",
        "SKI": "XUJQ4tgdREjYop786R0p/wdeyeI",
        "routerPublicKey": "MFkwEwYHKoZIzj0CAQYIKoZIzj0DAQcDQgAEgFcjQ/g//LAQerAH2Mpp+GucoDAGBbhIqD33wNPsXxnAGb+mtZ7XQrVO9DQ6UlAShtig5+QfEKpTtFgiqfiAFQ"
      }
    ],
    "aspaAssertions": [
      {
        "customerAsid": 64496,
        "providerSet": [64497, 64498],
        "comment": "Locally assert 64497 and 64498 are providers for 64496"
      }
    ]
  }
}

Security Considerations
For Security Considerations see Section 6 of [RFC8416].

IANA Considerations
This document has no IANA actions.

Acknowledgements
The authors would like to thank Tim Bruijnzeels for their helpful review of this document.

Normative References

Informative References
[stayrtr]

StayRTR
Ben Cartwright-Cox
Port 179 Ltd
2023
[RFC2119]
[RFC8174]
[RFC8416]
[RFC8259]
[I-D.ietf-sidrops-aspa-profile]
[I-D.ietf-sidrops-8210bis]

Implementation status - RFC EDITOR: REMOVE BEFORE PUBLICATION
This section records the status of known implementations of the protocol defined by this specification at the time of posting of this Internet-Draft, and is based on a proposal described in RFC 7942. The description of implementations in this section is intended to assist the IETF in its decision processes in progressing drafts to RFCs. Please note that the listing of any individual implementation here does not imply endorsement by the IETF. Furthermore, no effort has been spent to verify the information presented here that was supplied by IETF contributors. This is not intended as, and must not be construed to be, a catalog of available implementations or their features. Readers are advised to note that other implementations may exist.
According to RFC 7942, "this will allow reviewers and working groups to assign due consideration to documents that have the benefit of running code, which may serve as evidence of valuable experimentation and feedback that have made the implemented protocols more mature. It is up to the individual working groups to use this information as they see fit".
- StayRTR [stayrtr]